gamera = require 'libs/gamera'
timeout = require 'timeout'
graphics = require 'graphics'
pickcar = require 'pickcars'

game = require 'game'

highscore = 0
score = 0

--game
--pick
--postgame
--done

game_mode = "pick"
message = ""


function count_down()
    --Callback hell, but it works and is easier than 
    --setting up a million timers
    message = "Racing Game!"
    timeout.set(1, function()
        message = "3"
        timeout.set(1, function()
            message = "2"
            timeout.set(1, function()
                message = "1"
                timeout.set(1, function()
                    message = "Go!"
                        timeout.set(1, function()
                            message = ""
                        end)
                end)
            end)
        end)
    end)
end

function start() 
    game_mode = "pick"
    score = 0
    game.reset()
    game.hidePlayer()
end

function love.load()
    font1 = love.graphics.setNewFont(20)
    font2 = love.graphics.setNewFont(60)
    love.filesystem.setIdentity("s5Racing")
    readHighscore()
    pickcar.init()
    graphics.init()
    a = {x=0,y=0}
    contact_point = {x=0,y=0}
    down = false
    touch = {id=1}
    cam = gamera.new(-5,-6000,40,6100)
    cam:setScale(25.6)
    --cam:setScale(5)
    start()
end

function love.draw()
    cam:draw(function(l,t,w,h)
        game.draw()
    end)
    if(game_mode == "pick") then
        pickcar.draw()
    end
    love.graphics.setFont(font1)
    love.graphics.print("Time: ".. string.format("%.2f", score),10, 10)
    love.graphics.print("Best: ".. string.format("%.2f", highscore),10, 35)
    love.graphics.setFont(font2)
    love.graphics.printf(message, 0, 200, 800, 'center')
end

function saveHighscore()
        setHighscore()
        local file = love.filesystem.newFile( "data.txt" )
        file:open('w')
        file:write(highscore)
        file:close()
end

function readHighscore()
    if love.filesystem.isFile( "data.txt" ) then
        local file = love.filesystem.newFile( "data.txt" )
        file:open('r')
        highscore = file:read() + 0
    end
end

function setHighscore()
    if(score > highscore) then
        highscore = score
    end
end

function love.update(dt)
    timeout.update(dt)

    getDirection(contact_point.x,contact_point.y)

    if(game.lost == false and game.win == false and game_mode ~= "pick") then
        score = score + dt
        setHighscore()
    end

    if(game_mode ~= "pick") then
        game.update(dt, a)
    elseif(game_mode == "pick") then
        pickcar.update(dt)
        local selection = pickcar.selection
        if(selection ~= "") then
            game.setCar(selection)
            game_mode = "game"
            count_down()
            pickcar.reset()
        end
    end
    local focus = game.getFocus()
    cam:setPosition(focus.x, focus.y)

    if(game_mode ~= "done") then
        if (game.lost) then
            saveHighscore()
            message = "You lost\n Tap to restart"
            game_mode = "done"

        end

        if (game.win) then
            saveHighscore()
            message = "You've won!\n Tap to restart"
            game_mode = "done"
        end
    end
end


function love.keypressed(key)
   if key == "escape" then love.event.quit() end
   if key == "up"    then a.y = -1 end
   if key == "down"  then a.y =  1 end
   if key == "left"  then a.x = -1 end
   if key == "right" then a.x =  1 end
end

function love.keyreleased(key)
   if key == "escape" then love.event.quit() end
   if key == "up"    and a.y == -1  then a.y =  0 end
   if key == "down"  and a.y ==  1  then a.y =  0 end
   if key == "left"  and a.x == -1  then a.x =  0 end
   if key == "right" and a.x ==  1  then a.x =  0 end
end

function tapRestart() 
    if(game_mode == "done") then
        game_mode = "pick"
        message = ""
        start()
    end
end

function getDirection(x,y)
    if(down) then
        local ref = game.getRef()
        local wx, wy = cam:toWorld(x, y)
        local mag = math.sqrt((wx - ref.x)^2 + (wy - ref.y)^2)
        a.x = (wx - ref.x)/mag
        a.y = (wy - ref.y)/mag
    end
end

function love.touchpressed(id, x, y, button )
    contact_point = {x = x, y = y}
    down = true
end

function love.touchmoved(id, x, y, dx, dy )
    contact_point = {x = x, y = y}
end

function love.touchreleased(id, x, y, button )
    if(game_mode == "pick") then
        pickcar.setSelection(x,y)
    end
    down = false
    a.y = 0
    a.x = 0
end


function love.mousepressed(x, y, button )
    tapRestart()
    down = true
    getDirection(x,y)
end

function love.mousemoved( x, y, dx, dy )
    if (down) then
        contact_point = {x = x, y = y}
    end
end


function love.mousereleased( x, y, button )
    if(game_mode == "pick") then
        pickcar.setSelection(x,y)
    end
    down = false
    a.y = 0
    a.x = 0
end

