local _      = require 'libs/underscore'
local graphics = require 'graphics'
local v2   = require 'v2'


local pickcar = {}
local boxes = {}

pickcar.color = ""
pickcar.body = ""
pickcar.selection = ""

pickcar.init = function()
    pickcar.mode = "color"
    local colors = {"black", "blue", "green", "red", "yellow", "yellow"}
    local y = 200
    local i = 1
    boxes = {}
    _.each(colors, function(item) 
        box = {}
        box.color = item
        box.body = i
        box.x = i*75 + 140
        box.y = y
        box.w = 72
        box.h = 131
        _.push(boxes, box)
        i = i + 1
    end)
end

local id = 1

pickcar.draw = function()
    local x = 0
    if(pickcar.mode == "color") then
        love.graphics.printf("Pick color", 0, 100, 800, 'center')
    else 
        love.graphics.printf("Pick body", 0, 100, 800, 'center')
    end
    _.each(boxes, function(box)
        local car = ""
        local color = ""
        local body = ""
        if (pickcar.mode == "color") then
            if(pickcar.body == "") then
                body = "1"
            else
                body = pickcar.body
            end
            car = "car_" .. box.color .. "_".. body ..".png"
        elseif (pickcar.mode == "body") then
            if(pickcar.color == "") then
                color = "blue"
            else
                color = pickcar.color
            end
            car = "car_" .. color .. "_".. box.body ..".png"
        end
        graphics.imgs[car].draw(box.x, box.y, 0, 1)
    end)

end
pickcar.reset = function()
    pickcar.selection = ""
    pickcar.color = ""
    pickcar.body = ""
end

local timer = 0

pickcar.update = function(dt)
    timer = timer - dt
end

pickcar.setSelection = function(x,y, id)
    if(timer > 0) then 
        return
    else 
        timer = 1
    end

    local selection = false
    _.each(boxes, function(box)
        if(x > box.x and y > box.y and
           x < box.w + box.x and
           y < box.h + box.y) then
           selection = box
           return
       end
    end)

    if(selection ~= false) then
        if(pickcar.mode == "color") then
            pickcar.color = selection.color
            pickcar.mode = "body"
        elseif(pickcar.mode == "body") then
            pickcar.body = selection.body
            pickcar.mode = "color"
        end
        if( pickcar.color ~= "" and  pickcar.body ~= "") then
            pickcar.selection = "car_" .. pickcar.color .. "_" .. pickcar.body
            print(pickcar.selection)
        end

    end
end

return pickcar
