--TODO: Fix clean up function
local _      = require 'libs/underscore'
local bump   = require 'libs/bump'
local v2   = require 'v2'
local sounds = require 'sound'
local graphics = require 'graphics'
local timeout = require 'timeout'

local scale = 0.0390625 
local world = bump.newWorld(5)

local function isCar(name) 
    local car_list = {
        "car_black_1",
        "car_black_2",
        "car_black_3",
        "car_black_4",
        "car_black_5",
        "car_black_6",
        "car_blue_1",
        "car_blue_2",
        "car_blue_3",
        "car_blue_4",
        "car_blue_5",
        "car_blue_6",
        "car_green_1",
        "car_green_2",
        "car_green_3",
        "car_green_4",
        "car_green_5",
        "car_green_6",
        "car_red_1",
        "car_red_2",
        "car_red_3",
        "car_red_4",
        "car_red_5",
        "car_red_6",
        "car_yellow_1",
        "car_yellow_2",
        "car_yellow_3",
        "car_yellow_4",
        "car_yellow_5",
        "car_yellow_6"
    }
    local is_car = false
    _.each(car_list, function(car)
        if(name == car) then 
            is_car = true
        end
    end)
    return is_car
end

local rect = { 
    list = {}
}

rect.update = function (dt)

    local filter = function(item, other)
        if (item.name == "sweeper" and 
            other.name == "tile") then
            return "cross"
        end 

        if (item.name == "player" and
            other.name == "tent") then
                return "slide"
        end

        if (item.name == "player" and
            other.name == "topsweeper") then
                return "slide"
        end

        if (isCar(item.graphic) and
            other.name == "hazard") then
            if(other.graphic == "oil") then
                return "cross"
            end
            if (isCar(other.graphic) ) then
                 return "bounce"
            else
                return "bounce"
            end
        end

        if (item.name == "hazard" and
            other.name == "hazard") then
            if(other.graphic == "oil" or item.graphic == "oil") then
                return "cross"
            end
            return "touch"
        end

        return "cross"
    end

    local resolve = function(item, other, normal)
        if (item.name == "sweeper" and
            (other.name == 'road' or
             other.name == 'tent' or
             other.name == 'grass')) then
            other.p.y = other.p.y - 50
        end
        if (item.name == "sweeper" and
            other.name == 'player') then
            item.lost = true
            other.speed = 0
        end
        if (item.name == "sweeper" and
            other.name == 'hazard') then
            other.cleanup = true
        end
        if (item.name == "player" and
            other.name == 'win') then
            item.win = true
            item.speed = 0
        end
        if (item.name == "player" and
             other.name == 'grass') then
             item.grass = true
             item.speed = item.topspeed * 0.5
        end
        if (item.name == "player" and
           other.name == "hazard" and
           other.graphic == "oil") then
             if(other.stuck == false) then
                 sounds.add("sfx/goo.ogg", other, false, 1, 1)
             end
             other.stuck = true
             item.oil = true
             item.speed = item.topspeed * 0.3
        end
        if (item.name == "player" and
             other.name == 'road' and 
             item.oil == false and 
             item.grass == false) then
             item.speed = item.topspeed
        end
        if (isCar(item.graphic) and
             other.name == "hazard" and
             other.graphic == "cone_straight") then
             other.graphic = "cone_down"
            sounds.add("sfx/plopp.ogg", other, false, 1, 1)
        end
        if (isCar(item.graphic)  and
             other.name == "hazard" and
             other.graphic == "barrel_red") then
             other.graphic = "barrel_red_down"
             --other.updateBump()
             sounds.add("sfx/wooden_bridge.ogg", other, false, 1, 1)
             game.add_named_hazard("oil", other.p.x+other.w*3/4, other.p.y)
        end
        if (isCar(item.graphic) and
            other.name == "hazard" and
            other.graphic == "barrel_blue") then
             other.graphic = "barrel_blue_down"
             --other.updateBump()
             sounds.add("sfx/wooden_bridge.ogg", other, false, 1, 1)
             game.add_named_hazard("oil", other.p.x+other.w*3/4, other.p.y)
        end
        if (item.name == "player" and
             other.name == "hazard" and
             other.graphic ~= "oil") then
             item.col(other, normal)
        end

        if (item.name == "hazard" and
             other.name == "hazard" and
             other.graphic ~= "oil") then
             item.col(other, normal)
         end
    end

    local up = function(item)
        if(item.name == "player" or
           item.name == "hazard")  then
            item.v.x = item.v.x + ((item.f.x - item.b*item.v.x)/item.m)*dt;
            item.v.y = item.v.y + ((item.f.y - item.b*item.v.y + item.speed)/item.m + item.g)*dt;
        end

        local dx =  item.v.x*dt
        local dy =  item.v.y*dt

        if(item.name == "player" or 
            item.name == "hazard" or
            item.name == "sweeper") then
            item.p.x, item.p.y, cols, col_len = world:move(item, item.p.x + dx, item.p.y + dy, filter)
            _.each(cols,function(col)
                resolve(col.item, col.other, col.normal)
            end)

        else
            item.p.x = item.p.x + dx
            item.p.y = item.p.y + dy
            world:update(item, item.p.x , item.p.y)

        end
    end
    _.each(rect.list, up)

    
end


rect.reset = function ()
    rect.list = {}
    world = bump.newWorld(5)
end

rect.create = function (name,x,y,h,w)
    local obj = {
        name = name, 
        graphic = 'land_grass04', 
        p = v2.create(x,y),
        v = v2.create(0,0),
        f = v2.create(0,0),
        m = 1,
        g = 0,
        b = 5,
        r = 0,
        speed = 0,

        cleanup = false,
        h = h,
        w = w
    }

    local colresponse = function(v1, v2, m1, m2)
        local nv = (v1*(m1 - m2) + 2*m2*v2)/(m1 + m2)
        return nv
    end

    obj.col = function(other, normal)
        local v1
        local v2
        if(normal.x ~= 0)then
            v1 = .5*colresponse(obj.v.x, other.v.x, obj.m, other.m)
            v2 = .5*colresponse(other.v.x, obj.v.x, other.m, obj.m)
            obj.v.x = v1
            other.v.x = v2
        end
        if(normal.y ~= 0)then
            v1 = .5*colresponse(obj.v.y, other.v.y, obj.m, other.m)
            v2 = .5*colresponse(other.v.y, obj.v.y, other.m, obj.m)
            obj.v.y = v1
            other.v.y = v2
        end
    end

    obj.zeroForce = function()
        obj.f.x = 0
        obj.f.y = 0
    end
    
    obj.updateBump = function()
        obj.h = graphics.imgs[obj.graphic .. ".png"].h*scale
        obj.w = graphics.imgs[obj.graphic .. ".png"].w*scale
        world:update(obj, obj.p.x,obj.p.y,obj.w,obj.h)
    end

    obj.draw = function()
        graphics.imgs[obj.graphic .. ".png"].draw(obj.p.x+obj.w*math.sin(obj.r/2), obj.p.y+obj.h*math.sin(obj.r/2), obj.r, scale)
    end
    _.push(rect.list, obj)
    world:add(obj, obj.p.x,obj.p.y,obj.w,obj.h)
    return obj
end

rect.cleanupByName = function(name)
    local rejects = _.select(rect.list, function(item)
        return item.cleanup == true and item.name == name 
    end)

    _.each(rejects, function(item)
        sounds.stop(item)
        world:remove(item)
    end)

    rect.list = _.select(rect.list, function(item)
        return item.cleanup == false
    end)
end

rect.debugDraw = function()
    _.each(rect.list, function(item)
          --love.graphics.setColor(0,0,0)
          love.graphics.rectangle("line", item.p.x, item.p.y, item.w, item.h)
    end)
end

rect.zeroForce = function()
    _.each(rect.list, function(item)
        item.zeroForce()
    end)

end

return rect


