local _  = require 'libs/underscore'

local q = {}

local sounds = {}

sounds.add = function (sound, obj, loop, volume, pitch)
    local node = {}
    node.src = love.audio.newSource(sound, "static")
    node.obj = obj
    node.callbox = callback

    node.src:setPosition( obj.p.x, obj.p.y, 0 )
    node.src:setVelocity( obj.v.x, obj.v.y, 0 )
    node.src:setLooping( loop or false )
    node.src:setVolume( volume or 1 )
    node.src:setPitch( pitch or 1 )
    node.src:play()
    _.push(q, node)
end


sounds.cleanup = function ()
    _.each(q, function(node)
        node.src:stop()
    end)
    q = {}
end

sounds.pitch = function (obj, pitch)
    local list = _.select(q, function(node)
        return node.obj == obj
    end)
    _.each(list, function(node)
        node.src:setPitch(pitch)
    end)
end

sounds.stop = function (obj)
    local list = _.select(q, function(node)
        return node.obj == obj
    end)
    _.each(list, function(node)
        node.src:stop()
    end)
end

sounds.update = function (dt)

    local donelist = _.select(q, function(node)
        return node.src:isStopped()
    end)

    q = _.select(q, function(node)
        return node.src:isStopped() == false
    end)

    _.each(q, function(node)
        node.src:setPosition( node.obj.p.x, node.obj.p.y, 0 )
        node.src:setVelocity( node.obj.v.x, node.obj.v.y, 0 )
    end)

end

return sounds

