local _  = require 'libs/underscore'

local q = {}

local timeout = {}

timeout.set = function (time, callback)
    local node = {type = "set", time = time, callback = callback}
    _.push(q, node)
end

timeout.emit = function (time, callback)
    local node = {type = "emit", time = time, callback = callback}
    _.push(q, node)
end


timeout.update = function (dt)
    _.each(q, function(node)
        node.time = node.time - dt
        if(node.type == "emit") then
            node.callback()
        end
    end)

    local donelist = _.select(q, function(node)
        return node.time <= 0
    end)

    _.each(donelist, function(node)
        node.callback()
    end)

    q = _.select(q, function(node)
        return node.time > 0
    end)

end

return timeout
